/* GCC */
#include <iostream>
#include <vector>
using namespace std;
int main(){
    freopen("display.in", "r", stdin);
    freopen("display.out", "w", stdout);
    int n,m;
    scanf("%d %d", &n, &m);
    int n1,m1;
    scanf("%d %d", &n1, &m1);
    int k;
    scanf("%d", &k);
    int g[n][m];
    for (int i=0; i<n; i++)
    for (int j=0; j<m; j++)
    scanf("%d", &g[i][j]);
    int rez[n-n1+1][m-m1+1];
    if (g[0][0]==0) rez[0][0]=0;
    else rez[0][0]=k-g[0][0];
    int suma=rez[0][0];
    int kon;
    for (int i=1; i<n-n1+1; i++){
        if (g[i][0]==0) kon=0;
        else kon=k-g[i][0];
        if (kon-suma<0) rez[i][0]=k+kon-suma;
        else rez[i][0]=kon-suma;
        if (i<n1-1) suma=(suma+rez[i][0])%k;
        else if ((suma+rez[i][0]-rez[i-n1+1][0])>0)
        suma=(suma+rez[i][0]-rez[i-n1+1][0])%k;
        else suma=suma+rez[i][0]-rez[i-n1+1][0]+k;
        }
        
        
    for (int j=1; j<m-m1+1; j++){
        suma=0;
        if (j<m1){
                  for (int i=0; i<j; i++) suma=(suma+rez[0][i])%k;
                  }
        else{
             for (int i=j-m1+1; i<j; i++) suma=(suma+rez[0][i])%k;
             }
        if (g[0][j]==0) kon=0;
        else kon=k-g[0][j];
        if (kon-suma<0) rez[0][j]=kon+k-suma;
        else rez[0][j]=kon-suma;
        suma=(suma+rez[0][j])%k;
        
        
        for (int i=1; i<n-n1+1; i++){
              if (g[i][j]==0) kon=0;
              else kon=k-g[i][j];
        if (j<m1){
                  for (int t=0; t<j; t++) suma=(suma+rez[i][t])%k;
                  }
        else{
             for (int t=j-m1+1; t<j; t++) suma=(suma+rez[i][t])%k;
             }
        if (i>n1-1){
                    if (j<m1){
                  for (int t=0; t<=j; t++) if (suma-rez[i-n1][t]<0) suma=suma+k-g[i-n1][t];
                  else suma=suma-g[i-n1][t];
                  }
        else{
             for (int t=j-m1+1; t<=j; t++) if (suma-rez[i-n1][t]<0) suma=suma+k-g[i-n1][t];
                  else suma=suma-rez[i-n1][t];
             }
             }
              if (kon-suma<0) rez[i][j]=k+kon-suma;
              else rez[i][j]=kon-suma;
              suma=(suma+rez[i][j])%k;
        }
        }
    
    int kil=0; 
    for (int i=0; i<n-n1+1; i++)
    for (int j=0; j<m-m1+1; j++) kil+=rez[i][j];
    printf("%d\n", kil);
    fclose(stdin);
    fclose(stdout);
}
         
        
    
